-- These hex values were obtained from the Mesa header file gl.h.  
-- A quick glance at the Apple gl.h header file shows that at 
-- least some of the values are the same.  Maybe all of them are.
-- If not, I guess we'll find out soon enough.  -ijt

function hex_to_int(hstr) return tonumber(hstr,16) end

-- Boolean values 
GL_FALSE				= false
GL_TRUE					= true

-- Data types 
GL_BYTE					= hex_to_int("1400")
GL_UNSIGNED_BYTE			= hex_to_int("1401")
GL_SHORT				= hex_to_int("1402")
GL_UNSIGNED_SHORT			= hex_to_int("1403")
GL_INT					= hex_to_int("1404")
GL_UNSIGNED_INT				= hex_to_int("1405")
GL_FLOAT				= hex_to_int("1406")
GL_2_BYTES				= hex_to_int("1407")
GL_3_BYTES				= hex_to_int("1408")
GL_4_BYTES				= hex_to_int("1409")
GL_DOUBLE				= hex_to_int("140A")

-- Primitives 
GL_POINTS				= hex_to_int("0000")
GL_LINES				= hex_to_int("0001")
GL_LINE_LOOP				= hex_to_int("0002")
GL_LINE_STRIP				= hex_to_int("0003")
GL_TRIANGLES				= hex_to_int("0004")
GL_TRIANGLE_STRIP			= hex_to_int("0005")
GL_TRIANGLE_FAN				= hex_to_int("0006")
GL_QUADS				= hex_to_int("0007")
GL_QUAD_STRIP				= hex_to_int("0008")
GL_POLYGON				= hex_to_int("0009")

-- Vertex Arrays 
GL_VERTEX_ARRAY				= hex_to_int("8074")
GL_NORMAL_ARRAY				= hex_to_int("8075")
GL_COLOR_ARRAY				= hex_to_int("8076")
GL_INDEX_ARRAY				= hex_to_int("8077")
GL_TEXTURE_COORD_ARRAY			= hex_to_int("8078")
GL_EDGE_FLAG_ARRAY			= hex_to_int("8079")
GL_VERTEX_ARRAY_SIZE			= hex_to_int("807A")
GL_VERTEX_ARRAY_TYPE			= hex_to_int("807B")
GL_VERTEX_ARRAY_STRIDE			= hex_to_int("807C")
GL_NORMAL_ARRAY_TYPE			= hex_to_int("807E")
GL_NORMAL_ARRAY_STRIDE			= hex_to_int("807F")
GL_COLOR_ARRAY_SIZE			= hex_to_int("8081")
GL_COLOR_ARRAY_TYPE			= hex_to_int("8082")
GL_COLOR_ARRAY_STRIDE			= hex_to_int("8083")
GL_INDEX_ARRAY_TYPE			= hex_to_int("8085")
GL_INDEX_ARRAY_STRIDE			= hex_to_int("8086")
GL_TEXTURE_COORD_ARRAY_SIZE		= hex_to_int("8088")
GL_TEXTURE_COORD_ARRAY_TYPE		= hex_to_int("8089")
GL_TEXTURE_COORD_ARRAY_STRIDE		= hex_to_int("808A")
GL_EDGE_FLAG_ARRAY_STRIDE		= hex_to_int("808C")
GL_VERTEX_ARRAY_POINTER			= hex_to_int("808E")
GL_NORMAL_ARRAY_POINTER			= hex_to_int("808F")
GL_COLOR_ARRAY_POINTER			= hex_to_int("8090")
GL_INDEX_ARRAY_POINTER			= hex_to_int("8091")
GL_TEXTURE_COORD_ARRAY_POINTER		= hex_to_int("8092")
GL_EDGE_FLAG_ARRAY_POINTER		= hex_to_int("8093")
GL_V2F					= hex_to_int("2A20")
GL_V3F					= hex_to_int("2A21")
GL_C4UB_V2F				= hex_to_int("2A22")
GL_C4UB_V3F				= hex_to_int("2A23")
GL_C3F_V3F				= hex_to_int("2A24")
GL_N3F_V3F				= hex_to_int("2A25")
GL_C4F_N3F_V3F				= hex_to_int("2A26")
GL_T2F_V3F				= hex_to_int("2A27")
GL_T4F_V4F				= hex_to_int("2A28")
GL_T2F_C4UB_V3F				= hex_to_int("2A29")
GL_T2F_C3F_V3F				= hex_to_int("2A2A")
GL_T2F_N3F_V3F				= hex_to_int("2A2B")
GL_T2F_C4F_N3F_V3F			= hex_to_int("2A2C")
GL_T4F_C4F_N3F_V4F			= hex_to_int("2A2D")

-- Matrix Mode 
GL_MATRIX_MODE				= hex_to_int("0BA0")
GL_MODELVIEW				= hex_to_int("1700")
GL_PROJECTION				= hex_to_int("1701")
GL_TEXTURE				= hex_to_int("1702")

-- Points 
GL_POINT_SMOOTH				= hex_to_int("0B10")
GL_POINT_SIZE				= hex_to_int("0B11")
GL_POINT_SIZE_GRANULARITY 		= hex_to_int("0B13")
GL_POINT_SIZE_RANGE			= hex_to_int("0B12")

-- Lines 
GL_LINE_SMOOTH				= hex_to_int("0B20")
GL_LINE_STIPPLE				= hex_to_int("0B24")
GL_LINE_STIPPLE_PATTERN			= hex_to_int("0B25")
GL_LINE_STIPPLE_REPEAT			= hex_to_int("0B26")
GL_LINE_WIDTH				= hex_to_int("0B21")
GL_LINE_WIDTH_GRANULARITY		= hex_to_int("0B23")
GL_LINE_WIDTH_RANGE			= hex_to_int("0B22")

-- Polygons 
GL_POINT				= hex_to_int("1B00")
GL_LINE					= hex_to_int("1B01")
GL_FILL					= hex_to_int("1B02")
GL_CW					= hex_to_int("0900")
GL_CCW					= hex_to_int("0901")
GL_FRONT				= hex_to_int("0404")
GL_BACK					= hex_to_int("0405")
GL_POLYGON_MODE				= hex_to_int("0B40")
GL_POLYGON_SMOOTH			= hex_to_int("0B41")
GL_POLYGON_STIPPLE			= hex_to_int("0B42")
GL_EDGE_FLAG				= hex_to_int("0B43")
GL_CULL_FACE				= hex_to_int("0B44")
GL_CULL_FACE_MODE			= hex_to_int("0B45")
GL_FRONT_FACE				= hex_to_int("0B46")
GL_POLYGON_OFFSET_FACTOR		= hex_to_int("8038")
GL_POLYGON_OFFSET_UNITS			= hex_to_int("2A00")
GL_POLYGON_OFFSET_POINT			= hex_to_int("2A01")
GL_POLYGON_OFFSET_LINE			= hex_to_int("2A02")
GL_POLYGON_OFFSET_FILL			= hex_to_int("8037")

-- Display Lists 
GL_COMPILE				= hex_to_int("1300")
GL_COMPILE_AND_EXECUTE			= hex_to_int("1301")
GL_LIST_BASE				= hex_to_int("0B32")
GL_LIST_INDEX				= hex_to_int("0B33")
GL_LIST_MODE				= hex_to_int("0B30")

-- Depth buffer 
GL_NEVER				= hex_to_int("0200")
GL_LESS					= hex_to_int("0201")
GL_EQUAL				= hex_to_int("0202")
GL_LEQUAL				= hex_to_int("0203")
GL_GREATER				= hex_to_int("0204")
GL_NOTEQUAL				= hex_to_int("0205")
GL_GEQUAL				= hex_to_int("0206")
GL_ALWAYS				= hex_to_int("0207")
GL_DEPTH_TEST				= hex_to_int("0B71")
GL_DEPTH_BITS				= hex_to_int("0D56")
GL_DEPTH_CLEAR_VALUE			= hex_to_int("0B73")
GL_DEPTH_FUNC				= hex_to_int("0B74")
GL_DEPTH_RANGE				= hex_to_int("0B70")
GL_DEPTH_WRITEMASK			= hex_to_int("0B72")
GL_DEPTH_COMPONENT			= hex_to_int("1902")

-- Lighting 
GL_LIGHTING				= hex_to_int("0B50")
GL_LIGHT0				= hex_to_int("4000")
GL_LIGHT1				= hex_to_int("4001")
GL_LIGHT2				= hex_to_int("4002")
GL_LIGHT3				= hex_to_int("4003")
GL_LIGHT4				= hex_to_int("4004")
GL_LIGHT5				= hex_to_int("4005")
GL_LIGHT6				= hex_to_int("4006")
GL_LIGHT7				= hex_to_int("4007")
GL_SPOT_EXPONENT			= hex_to_int("1205")
GL_SPOT_CUTOFF				= hex_to_int("1206")
GL_CONSTANT_ATTENUATION			= hex_to_int("1207")
GL_LINEAR_ATTENUATION			= hex_to_int("1208")
GL_QUADRATIC_ATTENUATION		= hex_to_int("1209")
GL_AMBIENT				= hex_to_int("1200")
GL_DIFFUSE				= hex_to_int("1201")
GL_SPECULAR				= hex_to_int("1202")
GL_SHININESS				= hex_to_int("1601")
GL_EMISSION				= hex_to_int("1600")
GL_POSITION				= hex_to_int("1203")
GL_SPOT_DIRECTION			= hex_to_int("1204")
GL_AMBIENT_AND_DIFFUSE			= hex_to_int("1602")
GL_COLOR_INDEXES			= hex_to_int("1603")
GL_LIGHT_MODEL_TWO_SIDE			= hex_to_int("0B52")
GL_LIGHT_MODEL_LOCAL_VIEWER		= hex_to_int("0B51")
GL_LIGHT_MODEL_AMBIENT			= hex_to_int("0B53")
GL_FRONT_AND_BACK			= hex_to_int("0408")
GL_SHADE_MODEL				= hex_to_int("0B54")
GL_FLAT					= hex_to_int("1D00")
GL_SMOOTH				= hex_to_int("1D01")
GL_COLOR_MATERIAL			= hex_to_int("0B57")
GL_COLOR_MATERIAL_FACE			= hex_to_int("0B55")
GL_COLOR_MATERIAL_PARAMETER		= hex_to_int("0B56")
GL_NORMALIZE				= hex_to_int("0BA1")

-- User clipping planes 
GL_CLIP_PLANE0				= hex_to_int("3000")
GL_CLIP_PLANE1				= hex_to_int("3001")
GL_CLIP_PLANE2				= hex_to_int("3002")
GL_CLIP_PLANE3				= hex_to_int("3003")
GL_CLIP_PLANE4				= hex_to_int("3004")
GL_CLIP_PLANE5				= hex_to_int("3005")

-- Accumulation buffer 
GL_ACCUM_RED_BITS			= hex_to_int("0D58")
GL_ACCUM_GREEN_BITS			= hex_to_int("0D59")
GL_ACCUM_BLUE_BITS			= hex_to_int("0D5A")
GL_ACCUM_ALPHA_BITS			= hex_to_int("0D5B")
GL_ACCUM_CLEAR_VALUE			= hex_to_int("0B80")
GL_ACCUM				= hex_to_int("0100")
GL_ADD					= hex_to_int("0104")
GL_LOAD					= hex_to_int("0101")
GL_MULT					= hex_to_int("0103")
GL_RETURN				= hex_to_int("0102")

-- Alpha testing 
GL_ALPHA_TEST				= hex_to_int("0BC0")
GL_ALPHA_TEST_REF			= hex_to_int("0BC2")
GL_ALPHA_TEST_FUNC			= hex_to_int("0BC1")

-- Blending 
GL_BLEND				= hex_to_int("0BE2")
GL_BLEND_SRC				= hex_to_int("0BE1")
GL_BLEND_DST				= hex_to_int("0BE0")
GL_ZERO					= hex_to_int("0x0")
GL_ONE					= hex_to_int("0x1")
GL_SRC_COLOR				= hex_to_int("0300")
GL_ONE_MINUS_SRC_COLOR			= hex_to_int("0301")
GL_SRC_ALPHA				= hex_to_int("0302")
GL_ONE_MINUS_SRC_ALPHA			= hex_to_int("0303")
GL_DST_ALPHA				= hex_to_int("0304")
GL_ONE_MINUS_DST_ALPHA			= hex_to_int("0305")
GL_DST_COLOR				= hex_to_int("0306")
GL_ONE_MINUS_DST_COLOR			= hex_to_int("0307")
GL_SRC_ALPHA_SATURATE			= hex_to_int("0308")

-- Render Mode 
GL_FEEDBACK				= hex_to_int("1C01")
GL_RENDER				= hex_to_int("1C00")
GL_SELECT				= hex_to_int("1C02")

-- Feedback 
GL_2D					= hex_to_int("0600")
GL_3D					= hex_to_int("0601")
GL_3D_COLOR				= hex_to_int("0602")
GL_3D_COLOR_TEXTURE			= hex_to_int("0603")
GL_4D_COLOR_TEXTURE			= hex_to_int("0604")
GL_POINT_TOKEN				= hex_to_int("0701")
GL_LINE_TOKEN				= hex_to_int("0702")
GL_LINE_RESET_TOKEN			= hex_to_int("0707")
GL_POLYGON_TOKEN			= hex_to_int("0703")
GL_BITMAP_TOKEN				= hex_to_int("0704")
GL_DRAW_PIXEL_TOKEN			= hex_to_int("0705")
GL_COPY_PIXEL_TOKEN			= hex_to_int("0706")
GL_PASS_THROUGH_TOKEN			= hex_to_int("0700")
GL_FEEDBACK_BUFFER_POINTER		= hex_to_int("0DF0")
GL_FEEDBACK_BUFFER_SIZE			= hex_to_int("0DF1")
GL_FEEDBACK_BUFFER_TYPE			= hex_to_int("0DF2")

-- Selection 
GL_SELECTION_BUFFER_POINTER		= hex_to_int("0DF3")
GL_SELECTION_BUFFER_SIZE		= hex_to_int("0DF4")

-- Fog 
GL_FOG					= hex_to_int("0B60")
GL_FOG_MODE				= hex_to_int("0B65")
GL_FOG_DENSITY				= hex_to_int("0B62")
GL_FOG_COLOR				= hex_to_int("0B66")
GL_FOG_INDEX				= hex_to_int("0B61")
GL_FOG_START				= hex_to_int("0B63")
GL_FOG_END				= hex_to_int("0B64")
GL_LINEAR				= hex_to_int("2601")
GL_EXP					= hex_to_int("0800")
GL_EXP2					= hex_to_int("0801")

-- Logic Ops 
GL_LOGIC_OP				= hex_to_int("0BF1")
GL_INDEX_LOGIC_OP			= hex_to_int("0BF1")
GL_COLOR_LOGIC_OP			= hex_to_int("0BF2")
GL_LOGIC_OP_MODE			= hex_to_int("0BF0")
GL_CLEAR				= hex_to_int("1500")
GL_SET					= hex_to_int("150F")
GL_COPY					= hex_to_int("1503")
GL_COPY_INVERTED			= hex_to_int("150C")
GL_NOOP					= hex_to_int("1505")
GL_INVERT				= hex_to_int("150A")
GL_AND					= hex_to_int("1501")
GL_NAND					= hex_to_int("150E")
GL_OR					= hex_to_int("1507")
GL_NOR					= hex_to_int("1508")
GL_XOR					= hex_to_int("1506")
GL_EQUIV				= hex_to_int("1509")
GL_AND_REVERSE				= hex_to_int("1502")
GL_AND_INVERTED				= hex_to_int("1504")
GL_OR_REVERSE				= hex_to_int("150B")
GL_OR_INVERTED				= hex_to_int("150D")

-- Stencil 
GL_STENCIL_TEST				= hex_to_int("0B90")
GL_STENCIL_WRITEMASK			= hex_to_int("0B98")
GL_STENCIL_BITS				= hex_to_int("0D57")
GL_STENCIL_FUNC				= hex_to_int("0B92")
GL_STENCIL_VALUE_MASK			= hex_to_int("0B93")
GL_STENCIL_REF				= hex_to_int("0B97")
GL_STENCIL_FAIL				= hex_to_int("0B94")
GL_STENCIL_PASS_DEPTH_PASS		= hex_to_int("0B96")
GL_STENCIL_PASS_DEPTH_FAIL		= hex_to_int("0B95")
GL_STENCIL_CLEAR_VALUE			= hex_to_int("0B91")
GL_STENCIL_INDEX			= hex_to_int("1901")
GL_KEEP					= hex_to_int("1E00")
GL_REPLACE				= hex_to_int("1E01")
GL_INCR					= hex_to_int("1E02")
GL_DECR					= hex_to_int("1E03")

-- Buffers, Pixel Drawing/Reading 
GL_NONE					= hex_to_int("0x0")
GL_LEFT					= hex_to_int("0406")
GL_RIGHT				= hex_to_int("0407")
--GL_FRONT					0x0404 
--GL_BACK					0x0405 
--GL_FRONT_AND_BACK				0x0408 
GL_FRONT_LEFT				= hex_to_int("0400")
GL_FRONT_RIGHT				= hex_to_int("0401")
GL_BACK_LEFT				= hex_to_int("0402")
GL_BACK_RIGHT				= hex_to_int("0403")
GL_AUX0					= hex_to_int("0409")
GL_AUX1					= hex_to_int("040A")
GL_AUX2					= hex_to_int("040B")
GL_AUX3					= hex_to_int("040C")
GL_COLOR_INDEX				= hex_to_int("1900")
GL_RED					= hex_to_int("1903")
GL_GREEN				= hex_to_int("1904")
GL_BLUE					= hex_to_int("1905")
GL_ALPHA				= hex_to_int("1906")
GL_LUMINANCE				= hex_to_int("1909")
GL_LUMINANCE_ALPHA			= hex_to_int("190A")
GL_ALPHA_BITS				= hex_to_int("0D55")
GL_RED_BITS				= hex_to_int("0D52")
GL_GREEN_BITS				= hex_to_int("0D53")
GL_BLUE_BITS				= hex_to_int("0D54")
GL_INDEX_BITS				= hex_to_int("0D51")
GL_SUBPIXEL_BITS			= hex_to_int("0D50")
GL_AUX_BUFFERS				= hex_to_int("0C00")
GL_READ_BUFFER				= hex_to_int("0C02")
GL_DRAW_BUFFER				= hex_to_int("0C01")
GL_DOUBLEBUFFER				= hex_to_int("0C32")
GL_STEREO				= hex_to_int("0C33")
GL_BITMAP				= hex_to_int("1A00")
GL_COLOR				= hex_to_int("1800")
GL_DEPTH				= hex_to_int("1801")
GL_STENCIL				= hex_to_int("1802")
GL_DITHER				= hex_to_int("0BD0")
GL_RGB					= hex_to_int("1907")
GL_RGBA					= hex_to_int("1908")

-- Implementation limits 
GL_MAX_LIST_NESTING			= hex_to_int("0B31")
GL_MAX_ATTRIB_STACK_DEPTH		= hex_to_int("0D35")
GL_MAX_MODELVIEW_STACK_DEPTH		= hex_to_int("0D36")
GL_MAX_NAME_STACK_DEPTH			= hex_to_int("0D37")
GL_MAX_PROJECTION_STACK_DEPTH		= hex_to_int("0D38")
GL_MAX_TEXTURE_STACK_DEPTH		= hex_to_int("0D39")
GL_MAX_EVAL_ORDER			= hex_to_int("0D30")
GL_MAX_LIGHTS				= hex_to_int("0D31")
GL_MAX_CLIP_PLANES			= hex_to_int("0D32")
GL_MAX_TEXTURE_SIZE			= hex_to_int("0D33")
GL_MAX_PIXEL_MAP_TABLE			= hex_to_int("0D34")
GL_MAX_VIEWPORT_DIMS			= hex_to_int("0D3A")
GL_MAX_CLIENT_ATTRIB_STACK_DEPTH	= hex_to_int("0D3B")

-- Gets 
GL_ATTRIB_STACK_DEPTH			= hex_to_int("0BB0")
GL_CLIENT_ATTRIB_STACK_DEPTH		= hex_to_int("0BB1")
GL_COLOR_CLEAR_VALUE			= hex_to_int("0C22")
GL_COLOR_WRITEMASK			= hex_to_int("0C23")
GL_CURRENT_INDEX			= hex_to_int("0B01")
GL_CURRENT_COLOR			= hex_to_int("0B00")
GL_CURRENT_NORMAL			= hex_to_int("0B02")
GL_CURRENT_RASTER_COLOR			= hex_to_int("0B04")
GL_CURRENT_RASTER_DISTANCE		= hex_to_int("0B09")
GL_CURRENT_RASTER_INDEX			= hex_to_int("0B05")
GL_CURRENT_RASTER_POSITION		= hex_to_int("0B07")
GL_CURRENT_RASTER_TEXTURE_COORDS	= hex_to_int("0B06")
GL_CURRENT_RASTER_POSITION_VALID	= hex_to_int("0B08")
GL_CURRENT_TEXTURE_COORDS		= hex_to_int("0B03")
GL_INDEX_CLEAR_VALUE			= hex_to_int("0C20")
GL_INDEX_MODE				= hex_to_int("0C30")
GL_INDEX_WRITEMASK			= hex_to_int("0C21")
GL_MODELVIEW_MATRIX			= hex_to_int("0BA6")
GL_MODELVIEW_STACK_DEPTH		= hex_to_int("0BA3")
GL_NAME_STACK_DEPTH			= hex_to_int("0D70")
GL_PROJECTION_MATRIX			= hex_to_int("0BA7")
GL_PROJECTION_STACK_DEPTH		= hex_to_int("0BA4")
GL_RENDER_MODE				= hex_to_int("0C40")
GL_RGBA_MODE				= hex_to_int("0C31")
GL_TEXTURE_MATRIX			= hex_to_int("0BA8")
GL_TEXTURE_STACK_DEPTH			= hex_to_int("0BA5")
GL_VIEWPORT				= hex_to_int("0BA2")

-- Evaluators 
GL_AUTO_NORMAL				= hex_to_int("0D80")
GL_MAP1_COLOR_4				= hex_to_int("0D90")
GL_MAP1_INDEX				= hex_to_int("0D91")
GL_MAP1_NORMAL				= hex_to_int("0D92")
GL_MAP1_TEXTURE_COORD_1			= hex_to_int("0D93")
GL_MAP1_TEXTURE_COORD_2			= hex_to_int("0D94")
GL_MAP1_TEXTURE_COORD_3			= hex_to_int("0D95")
GL_MAP1_TEXTURE_COORD_4			= hex_to_int("0D96")
GL_MAP1_VERTEX_3			= hex_to_int("0D97")
GL_MAP1_VERTEX_4			= hex_to_int("0D98")
GL_MAP2_COLOR_4				= hex_to_int("0DB0")
GL_MAP2_INDEX				= hex_to_int("0DB1")
GL_MAP2_NORMAL				= hex_to_int("0DB2")
GL_MAP2_TEXTURE_COORD_1			= hex_to_int("0DB3")
GL_MAP2_TEXTURE_COORD_2			= hex_to_int("0DB4")
GL_MAP2_TEXTURE_COORD_3			= hex_to_int("0DB5")
GL_MAP2_TEXTURE_COORD_4			= hex_to_int("0DB6")
GL_MAP2_VERTEX_3			= hex_to_int("0DB7")
GL_MAP2_VERTEX_4			= hex_to_int("0DB8")
GL_MAP1_GRID_DOMAIN			= hex_to_int("0DD0")
GL_MAP1_GRID_SEGMENTS			= hex_to_int("0DD1")
GL_MAP2_GRID_DOMAIN			= hex_to_int("0DD2")
GL_MAP2_GRID_SEGMENTS			= hex_to_int("0DD3")
GL_COEFF				= hex_to_int("0A00")
GL_DOMAIN				= hex_to_int("0A02")
GL_ORDER				= hex_to_int("0A01")

-- Hints 
GL_FOG_HINT				= hex_to_int("0C54")
GL_LINE_SMOOTH_HINT			= hex_to_int("0C52")
GL_PERSPECTIVE_CORRECTION_HINT		= hex_to_int("0C50")
GL_POINT_SMOOTH_HINT			= hex_to_int("0C51")
GL_POLYGON_SMOOTH_HINT			= hex_to_int("0C53")
GL_DONT_CARE				= hex_to_int("1100")
GL_FASTEST				= hex_to_int("1101")
GL_NICEST				= hex_to_int("1102")

-- Scissor box 
GL_SCISSOR_TEST				= hex_to_int("0C11")
GL_SCISSOR_BOX				= hex_to_int("0C10")

-- Pixel Mode / Transfer 
GL_MAP_COLOR				= hex_to_int("0D10")
GL_MAP_STENCIL				= hex_to_int("0D11")
GL_INDEX_SHIFT				= hex_to_int("0D12")
GL_INDEX_OFFSET				= hex_to_int("0D13")
GL_RED_SCALE				= hex_to_int("0D14")
GL_RED_BIAS				= hex_to_int("0D15")
GL_GREEN_SCALE				= hex_to_int("0D18")
GL_GREEN_BIAS				= hex_to_int("0D19")
GL_BLUE_SCALE				= hex_to_int("0D1A")
GL_BLUE_BIAS				= hex_to_int("0D1B")
GL_ALPHA_SCALE				= hex_to_int("0D1C")
GL_ALPHA_BIAS				= hex_to_int("0D1D")
GL_DEPTH_SCALE				= hex_to_int("0D1E")
GL_DEPTH_BIAS				= hex_to_int("0D1F")
GL_PIXEL_MAP_S_TO_S_SIZE		= hex_to_int("0CB1")
GL_PIXEL_MAP_I_TO_I_SIZE		= hex_to_int("0CB0")
GL_PIXEL_MAP_I_TO_R_SIZE		= hex_to_int("0CB2")
GL_PIXEL_MAP_I_TO_G_SIZE		= hex_to_int("0CB3")
GL_PIXEL_MAP_I_TO_B_SIZE		= hex_to_int("0CB4")
GL_PIXEL_MAP_I_TO_A_SIZE		= hex_to_int("0CB5")
GL_PIXEL_MAP_R_TO_R_SIZE		= hex_to_int("0CB6")
GL_PIXEL_MAP_G_TO_G_SIZE		= hex_to_int("0CB7")
GL_PIXEL_MAP_B_TO_B_SIZE		= hex_to_int("0CB8")
GL_PIXEL_MAP_A_TO_A_SIZE		= hex_to_int("0CB9")
GL_PIXEL_MAP_S_TO_S			= hex_to_int("0C71")
GL_PIXEL_MAP_I_TO_I			= hex_to_int("0C70")
GL_PIXEL_MAP_I_TO_R			= hex_to_int("0C72")
GL_PIXEL_MAP_I_TO_G			= hex_to_int("0C73")
GL_PIXEL_MAP_I_TO_B			= hex_to_int("0C74")
GL_PIXEL_MAP_I_TO_A			= hex_to_int("0C75")
GL_PIXEL_MAP_R_TO_R			= hex_to_int("0C76")
GL_PIXEL_MAP_G_TO_G			= hex_to_int("0C77")
GL_PIXEL_MAP_B_TO_B			= hex_to_int("0C78")
GL_PIXEL_MAP_A_TO_A			= hex_to_int("0C79")
GL_PACK_ALIGNMENT			= hex_to_int("0D05")
GL_PACK_LSB_FIRST			= hex_to_int("0D01")
GL_PACK_ROW_LENGTH			= hex_to_int("0D02")
GL_PACK_SKIP_PIXELS			= hex_to_int("0D04")
GL_PACK_SKIP_ROWS			= hex_to_int("0D03")
GL_PACK_SWAP_BYTES			= hex_to_int("0D00")
GL_UNPACK_ALIGNMENT			= hex_to_int("0CF5")
GL_UNPACK_LSB_FIRST			= hex_to_int("0CF1")
GL_UNPACK_ROW_LENGTH			= hex_to_int("0CF2")
GL_UNPACK_SKIP_PIXELS			= hex_to_int("0CF4")
GL_UNPACK_SKIP_ROWS			= hex_to_int("0CF3")
GL_UNPACK_SWAP_BYTES			= hex_to_int("0CF0")
GL_ZOOM_X				= hex_to_int("0D16")
GL_ZOOM_Y				= hex_to_int("0D17")

-- Texture mapping 
GL_TEXTURE_ENV				= hex_to_int("2300")
GL_TEXTURE_ENV_MODE			= hex_to_int("2200")
GL_TEXTURE_1D				= hex_to_int("0DE0")
GL_TEXTURE_2D				= hex_to_int("0DE1")
GL_TEXTURE_WRAP_S			= hex_to_int("2802")
GL_TEXTURE_WRAP_T			= hex_to_int("2803")
GL_TEXTURE_MAG_FILTER			= hex_to_int("2800")
GL_TEXTURE_MIN_FILTER			= hex_to_int("2801")
GL_TEXTURE_ENV_COLOR			= hex_to_int("2201")
GL_TEXTURE_GEN_S			= hex_to_int("0C60")
GL_TEXTURE_GEN_T			= hex_to_int("0C61")
GL_TEXTURE_GEN_MODE			= hex_to_int("2500")
GL_TEXTURE_BORDER_COLOR			= hex_to_int("1004")
GL_TEXTURE_WIDTH			= hex_to_int("1000")
GL_TEXTURE_HEIGHT			= hex_to_int("1001")
GL_TEXTURE_BORDER			= hex_to_int("1005")
GL_TEXTURE_COMPONENTS			= hex_to_int("1003")
GL_TEXTURE_RED_SIZE			= hex_to_int("805C")
GL_TEXTURE_GREEN_SIZE			= hex_to_int("805D")
GL_TEXTURE_BLUE_SIZE			= hex_to_int("805E")
GL_TEXTURE_ALPHA_SIZE			= hex_to_int("805F")
GL_TEXTURE_LUMINANCE_SIZE		= hex_to_int("8060")
GL_TEXTURE_INTENSITY_SIZE		= hex_to_int("8061")
GL_NEAREST_MIPMAP_NEAREST		= hex_to_int("2700")
GL_NEAREST_MIPMAP_LINEAR		= hex_to_int("2702")
GL_LINEAR_MIPMAP_NEAREST		= hex_to_int("2701")
GL_LINEAR_MIPMAP_LINEAR			= hex_to_int("2703")
GL_OBJECT_LINEAR			= hex_to_int("2401")
GL_OBJECT_PLANE				= hex_to_int("2501")
GL_EYE_LINEAR				= hex_to_int("2400")
GL_EYE_PLANE				= hex_to_int("2502")
GL_SPHERE_MAP				= hex_to_int("2402")
GL_DECAL				= hex_to_int("2101")
GL_MODULATE				= hex_to_int("2100")
GL_NEAREST				= hex_to_int("2600")
GL_REPEAT				= hex_to_int("2901")
GL_CLAMP				= hex_to_int("2900")
GL_S					= hex_to_int("2000")
GL_T					= hex_to_int("2001")
GL_R					= hex_to_int("2002")
GL_Q					= hex_to_int("2003")
GL_TEXTURE_GEN_R			= hex_to_int("0C62")
GL_TEXTURE_GEN_Q			= hex_to_int("0C63")

-- Utility 
GL_VENDOR				= hex_to_int("1F00")
GL_RENDERER				= hex_to_int("1F01")
GL_VERSION				= hex_to_int("1F02")
GL_EXTENSIONS				= hex_to_int("1F03")

-- Errors 
GL_NO_ERROR 				= hex_to_int("0x0")
GL_INVALID_VALUE			= hex_to_int("0501")
GL_INVALID_ENUM				= hex_to_int("0500")
GL_INVALID_OPERATION			= hex_to_int("0502")
GL_STACK_OVERFLOW			= hex_to_int("0503")
GL_STACK_UNDERFLOW			= hex_to_int("0504")
GL_OUT_OF_MEMORY			= hex_to_int("0505")

-- glPush/PopAttrib bits 
GL_CURRENT_BIT				= hex_to_int("00000001")
GL_POINT_BIT				= hex_to_int("00000002")
GL_LINE_BIT				= hex_to_int("00000004")
GL_POLYGON_BIT				= hex_to_int("00000008")
GL_POLYGON_STIPPLE_BIT			= hex_to_int("00000010")
GL_PIXEL_MODE_BIT			= hex_to_int("00000020")
GL_LIGHTING_BIT				= hex_to_int("00000040")
GL_FOG_BIT				= hex_to_int("00000080")
GL_DEPTH_BUFFER_BIT			= hex_to_int("00000100")
GL_ACCUM_BUFFER_BIT			= hex_to_int("00000200")
GL_STENCIL_BUFFER_BIT			= hex_to_int("00000400")
GL_VIEWPORT_BIT				= hex_to_int("00000800")
GL_TRANSFORM_BIT			= hex_to_int("00001000")
GL_ENABLE_BIT				= hex_to_int("00002000")
GL_COLOR_BUFFER_BIT			= hex_to_int("00004000")
GL_HINT_BIT				= hex_to_int("00008000")
GL_EVAL_BIT				= hex_to_int("00010000")
GL_LIST_BIT				= hex_to_int("00020000")
GL_TEXTURE_BIT				= hex_to_int("00040000")
GL_SCISSOR_BIT				= hex_to_int("00080000")
GL_ALL_ATTRIB_BITS			= hex_to_int("000FFFFF")


-- OpenGL 1.1 
GL_PROXY_TEXTURE_1D			= hex_to_int("8063")
GL_PROXY_TEXTURE_2D			= hex_to_int("8064")
GL_TEXTURE_PRIORITY			= hex_to_int("8066")
GL_TEXTURE_RESIDENT			= hex_to_int("8067")
GL_TEXTURE_BINDING_1D			= hex_to_int("8068")
GL_TEXTURE_BINDING_2D			= hex_to_int("8069")
GL_TEXTURE_INTERNAL_FORMAT		= hex_to_int("1003")
GL_ALPHA4				= hex_to_int("803B")
GL_ALPHA8				= hex_to_int("803C")
GL_ALPHA12				= hex_to_int("803D")
GL_ALPHA16				= hex_to_int("803E")
GL_LUMINANCE4				= hex_to_int("803F")
GL_LUMINANCE8				= hex_to_int("8040")
GL_LUMINANCE12				= hex_to_int("8041")
GL_LUMINANCE16				= hex_to_int("8042")
GL_LUMINANCE4_ALPHA4			= hex_to_int("8043")
GL_LUMINANCE6_ALPHA2			= hex_to_int("8044")
GL_LUMINANCE8_ALPHA8			= hex_to_int("8045")
GL_LUMINANCE12_ALPHA4			= hex_to_int("8046")
GL_LUMINANCE12_ALPHA12			= hex_to_int("8047")
GL_LUMINANCE16_ALPHA16			= hex_to_int("8048")
GL_INTENSITY				= hex_to_int("8049")
GL_INTENSITY4				= hex_to_int("804A")
GL_INTENSITY8				= hex_to_int("804B")
GL_INTENSITY12				= hex_to_int("804C")
GL_INTENSITY16				= hex_to_int("804D")
GL_R3_G3_B2				= hex_to_int("2A10")
GL_RGB4					= hex_to_int("804F")
GL_RGB5					= hex_to_int("8050")
GL_RGB8					= hex_to_int("8051")
GL_RGB10				= hex_to_int("8052")
GL_RGB12				= hex_to_int("8053")
GL_RGB16				= hex_to_int("8054")
GL_RGBA2				= hex_to_int("8055")
GL_RGBA4				= hex_to_int("8056")
GL_RGB5_A1				= hex_to_int("8057")
GL_RGBA8				= hex_to_int("8058")
GL_RGB10_A2				= hex_to_int("8059")
GL_RGBA12				= hex_to_int("805A")
GL_RGBA16				= hex_to_int("805B")
GL_CLIENT_PIXEL_STORE_BIT		= hex_to_int("00000001")
GL_CLIENT_VERTEX_ARRAY_BIT		= hex_to_int("00000002")
GL_ALL_CLIENT_ATTRIB_BITS 		= hex_to_int("FFFFFFFF")
GL_CLIENT_ALL_ATTRIB_BITS 		= hex_to_int("FFFFFFFF")

GL_RESCALE_NORMAL			= hex_to_int("803A")
GL_CLAMP_TO_EDGE			= hex_to_int("812F")
GL_MAX_ELEMENTS_VERTICES		= hex_to_int("80E8")
GL_MAX_ELEMENTS_INDICES			= hex_to_int("80E9")
GL_BGR					= hex_to_int("80E0")
GL_BGRA					= hex_to_int("80E1")
GL_UNSIGNED_BYTE_3_3_2			= hex_to_int("8032")
GL_UNSIGNED_BYTE_2_3_3_REV		= hex_to_int("8362")
GL_UNSIGNED_SHORT_5_6_5			= hex_to_int("8363")
GL_UNSIGNED_SHORT_5_6_5_REV		= hex_to_int("8364")
GL_UNSIGNED_SHORT_4_4_4_4		= hex_to_int("8033")
GL_UNSIGNED_SHORT_4_4_4_4_REV		= hex_to_int("8365")
GL_UNSIGNED_SHORT_5_5_5_1		= hex_to_int("8034")
GL_UNSIGNED_SHORT_1_5_5_5_REV		= hex_to_int("8366")
GL_UNSIGNED_INT_8_8_8_8			= hex_to_int("8035")
GL_UNSIGNED_INT_8_8_8_8_REV		= hex_to_int("8367")
GL_UNSIGNED_INT_10_10_10_2		= hex_to_int("8036")
GL_UNSIGNED_INT_2_10_10_10_REV		= hex_to_int("8368")
GL_LIGHT_MODEL_COLOR_CONTROL		= hex_to_int("81F8")
GL_SINGLE_COLOR				= hex_to_int("81F9")
GL_SEPARATE_SPECULAR_COLOR		= hex_to_int("81FA")
GL_TEXTURE_MIN_LOD			= hex_to_int("813A")
GL_TEXTURE_MAX_LOD			= hex_to_int("813B")
GL_TEXTURE_BASE_LEVEL			= hex_to_int("813C")
GL_TEXTURE_MAX_LEVEL			= hex_to_int("813D")
GL_SMOOTH_POINT_SIZE_RANGE		= hex_to_int("0B12")
GL_SMOOTH_POINT_SIZE_GRANULARITY	= hex_to_int("0B13")
GL_SMOOTH_LINE_WIDTH_RANGE		= hex_to_int("0B22")
GL_SMOOTH_LINE_WIDTH_GRANULARITY	= hex_to_int("0B23")
GL_ALIASED_POINT_SIZE_RANGE		= hex_to_int("846D")
GL_ALIASED_LINE_WIDTH_RANGE		= hex_to_int("846E")
GL_PACK_SKIP_IMAGES			= hex_to_int("806B")
GL_PACK_IMAGE_HEIGHT			= hex_to_int("806C")
GL_UNPACK_SKIP_IMAGES			= hex_to_int("806D")
GL_UNPACK_IMAGE_HEIGHT			= hex_to_int("806E")
GL_TEXTURE_3D				= hex_to_int("806F")
GL_PROXY_TEXTURE_3D			= hex_to_int("8070")
GL_TEXTURE_DEPTH			= hex_to_int("8071")
GL_TEXTURE_WRAP_R			= hex_to_int("8072")
GL_MAX_3D_TEXTURE_SIZE			= hex_to_int("8073")
GL_TEXTURE_BINDING_3D			= hex_to_int("806A")

GL_CONSTANT_COLOR			= hex_to_int("8001")
GL_ONE_MINUS_CONSTANT_COLOR		= hex_to_int("8002")
GL_CONSTANT_ALPHA			= hex_to_int("8003")
GL_ONE_MINUS_CONSTANT_ALPHA		= hex_to_int("8004")
GL_COLOR_TABLE				= hex_to_int("80D0")
GL_POST_CONVOLUTION_COLOR_TABLE		= hex_to_int("80D1")
GL_POST_COLOR_MATRIX_COLOR_TABLE	= hex_to_int("80D2")
GL_PROXY_COLOR_TABLE			= hex_to_int("80D3")
GL_PROXY_POST_CONVOLUTION_COLOR_TABLE	= hex_to_int("80D4")
GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE	= hex_to_int("80D5")
GL_COLOR_TABLE_SCALE			= hex_to_int("80D6")
GL_COLOR_TABLE_BIAS			= hex_to_int("80D7")
GL_COLOR_TABLE_FORMAT			= hex_to_int("80D8")
GL_COLOR_TABLE_WIDTH			= hex_to_int("80D9")
GL_COLOR_TABLE_RED_SIZE			= hex_to_int("80DA")
GL_COLOR_TABLE_GREEN_SIZE		= hex_to_int("80DB")
GL_COLOR_TABLE_BLUE_SIZE		= hex_to_int("80DC")
GL_COLOR_TABLE_ALPHA_SIZE		= hex_to_int("80DD")
GL_COLOR_TABLE_LUMINANCE_SIZE		= hex_to_int("80DE")
GL_COLOR_TABLE_INTENSITY_SIZE		= hex_to_int("80DF")
GL_CONVOLUTION_1D			= hex_to_int("8010")
GL_CONVOLUTION_2D			= hex_to_int("8011")
GL_SEPARABLE_2D				= hex_to_int("8012")
GL_CONVOLUTION_BORDER_MODE		= hex_to_int("8013")
GL_CONVOLUTION_FILTER_SCALE		= hex_to_int("8014")
GL_CONVOLUTION_FILTER_BIAS		= hex_to_int("8015")
GL_REDUCE				= hex_to_int("8016")
GL_CONVOLUTION_FORMAT			= hex_to_int("8017")
GL_CONVOLUTION_WIDTH			= hex_to_int("8018")
GL_CONVOLUTION_HEIGHT			= hex_to_int("8019")
GL_MAX_CONVOLUTION_WIDTH		= hex_to_int("801A")
GL_MAX_CONVOLUTION_HEIGHT		= hex_to_int("801B")
GL_POST_CONVOLUTION_RED_SCALE		= hex_to_int("801C")
GL_POST_CONVOLUTION_GREEN_SCALE		= hex_to_int("801D")
GL_POST_CONVOLUTION_BLUE_SCALE		= hex_to_int("801E")
GL_POST_CONVOLUTION_ALPHA_SCALE		= hex_to_int("801F")
GL_POST_CONVOLUTION_RED_BIAS		= hex_to_int("8020")
GL_POST_CONVOLUTION_GREEN_BIAS		= hex_to_int("8021")
GL_POST_CONVOLUTION_BLUE_BIAS		= hex_to_int("8022")
GL_POST_CONVOLUTION_ALPHA_BIAS		= hex_to_int("8023")
GL_CONSTANT_BORDER			= hex_to_int("8151")
GL_REPLICATE_BORDER			= hex_to_int("8153")
GL_CONVOLUTION_BORDER_COLOR		= hex_to_int("8154")
GL_COLOR_MATRIX				= hex_to_int("80B1")
GL_COLOR_MATRIX_STACK_DEPTH		= hex_to_int("80B2")
GL_MAX_COLOR_MATRIX_STACK_DEPTH		= hex_to_int("80B3")
GL_POST_COLOR_MATRIX_RED_SCALE		= hex_to_int("80B4")
GL_POST_COLOR_MATRIX_GREEN_SCALE	= hex_to_int("80B5")
GL_POST_COLOR_MATRIX_BLUE_SCALE		= hex_to_int("80B6")
GL_POST_COLOR_MATRIX_ALPHA_SCALE	= hex_to_int("80B7")
GL_POST_COLOR_MATRIX_RED_BIAS		= hex_to_int("80B8")
GL_POST_COLOR_MATRIX_GREEN_BIAS		= hex_to_int("80B9")
GL_POST_COLOR_MATRIX_BLUE_BIAS		= hex_to_int("80BA")
GL_POST_COLOR_MATRIX_ALPHA_BIAS		= hex_to_int("80BB")
GL_HISTOGRAM				= hex_to_int("8024")
GL_PROXY_HISTOGRAM			= hex_to_int("8025")
GL_HISTOGRAM_WIDTH			= hex_to_int("8026")
GL_HISTOGRAM_FORMAT			= hex_to_int("8027")
GL_HISTOGRAM_RED_SIZE			= hex_to_int("8028")
GL_HISTOGRAM_GREEN_SIZE			= hex_to_int("8029")
GL_HISTOGRAM_BLUE_SIZE			= hex_to_int("802A")
GL_HISTOGRAM_ALPHA_SIZE			= hex_to_int("802B")
GL_HISTOGRAM_LUMINANCE_SIZE		= hex_to_int("802C")
GL_HISTOGRAM_SINK			= hex_to_int("802D")
GL_MINMAX				= hex_to_int("802E")
GL_MINMAX_FORMAT			= hex_to_int("802F")
GL_MINMAX_SINK				= hex_to_int("8030")
GL_TABLE_TOO_LARGE			= hex_to_int("8031")
GL_BLEND_EQUATION			= hex_to_int("8009")
GL_MIN					= hex_to_int("8007")
GL_MAX					= hex_to_int("8008")
GL_FUNC_ADD				= hex_to_int("8006")
GL_FUNC_SUBTRACT			= hex_to_int("800A")
GL_FUNC_REVERSE_SUBTRACT		= hex_to_int("800B")
GL_BLEND_COLOR				= hex_to_int("8005")


-- multitexture 
GL_TEXTURE0				= hex_to_int("84C0")
GL_TEXTURE1				= hex_to_int("84C1")
GL_TEXTURE2				= hex_to_int("84C2")
GL_TEXTURE3				= hex_to_int("84C3")
GL_TEXTURE4				= hex_to_int("84C4")
GL_TEXTURE5				= hex_to_int("84C5")
GL_TEXTURE6				= hex_to_int("84C6")
GL_TEXTURE7				= hex_to_int("84C7")
GL_TEXTURE8				= hex_to_int("84C8")
GL_TEXTURE9				= hex_to_int("84C9")
GL_TEXTURE10				= hex_to_int("84CA")
GL_TEXTURE11				= hex_to_int("84CB")
GL_TEXTURE12				= hex_to_int("84CC")
GL_TEXTURE13				= hex_to_int("84CD")
GL_TEXTURE14				= hex_to_int("84CE")
GL_TEXTURE15				= hex_to_int("84CF")
GL_TEXTURE16				= hex_to_int("84D0")
GL_TEXTURE17				= hex_to_int("84D1")
GL_TEXTURE18				= hex_to_int("84D2")
GL_TEXTURE19				= hex_to_int("84D3")
GL_TEXTURE20				= hex_to_int("84D4")
GL_TEXTURE21				= hex_to_int("84D5")
GL_TEXTURE22				= hex_to_int("84D6")
GL_TEXTURE23				= hex_to_int("84D7")
GL_TEXTURE24				= hex_to_int("84D8")
GL_TEXTURE25				= hex_to_int("84D9")
GL_TEXTURE26				= hex_to_int("84DA")
GL_TEXTURE27				= hex_to_int("84DB")
GL_TEXTURE28				= hex_to_int("84DC")
GL_TEXTURE29				= hex_to_int("84DD")
GL_TEXTURE30				= hex_to_int("84DE")
GL_TEXTURE31				= hex_to_int("84DF")
GL_ACTIVE_TEXTURE			= hex_to_int("84E0")
GL_CLIENT_ACTIVE_TEXTURE		= hex_to_int("84E1")
GL_MAX_TEXTURE_UNITS			= hex_to_int("84E2")

-- texture_cube_map 
GL_NORMAL_MAP				= hex_to_int("8511")
GL_REFLECTION_MAP			= hex_to_int("8512")
GL_TEXTURE_CUBE_MAP			= hex_to_int("8513")
GL_TEXTURE_BINDING_CUBE_MAP		= hex_to_int("8514")
GL_TEXTURE_CUBE_MAP_POSITIVE_X		= hex_to_int("8515")
GL_TEXTURE_CUBE_MAP_NEGATIVE_X		= hex_to_int("8516")
GL_TEXTURE_CUBE_MAP_POSITIVE_Y		= hex_to_int("8517")
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y		= hex_to_int("8518")
GL_TEXTURE_CUBE_MAP_POSITIVE_Z		= hex_to_int("8519")
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z		= hex_to_int("851A")
GL_PROXY_TEXTURE_CUBE_MAP		= hex_to_int("851B")
GL_MAX_CUBE_MAP_TEXTURE_SIZE		= hex_to_int("851C")

-- texture_compression 
GL_COMPRESSED_ALPHA			= hex_to_int("84E9")
GL_COMPRESSED_LUMINANCE			= hex_to_int("84EA")
GL_COMPRESSED_LUMINANCE_ALPHA		= hex_to_int("84EB")
GL_COMPRESSED_INTENSITY			= hex_to_int("84EC")
GL_COMPRESSED_RGB			= hex_to_int("84ED")
GL_COMPRESSED_RGBA			= hex_to_int("84EE")
GL_TEXTURE_COMPRESSION_HINT		= hex_to_int("84EF")
GL_TEXTURE_COMPRESSED_IMAGE_SIZE	= hex_to_int("86A0")
GL_TEXTURE_COMPRESSED			= hex_to_int("86A1")
GL_NUM_COMPRESSED_TEXTURE_FORMATS	= hex_to_int("86A2")
GL_COMPRESSED_TEXTURE_FORMATS		= hex_to_int("86A3")

-- multisample 
GL_MULTISAMPLE				= hex_to_int("809D")
GL_SAMPLE_ALPHA_TO_COVERAGE		= hex_to_int("809E")
GL_SAMPLE_ALPHA_TO_ONE			= hex_to_int("809F")
GL_SAMPLE_COVERAGE			= hex_to_int("80A0")
GL_SAMPLE_BUFFERS			= hex_to_int("80A8")
GL_SAMPLES				= hex_to_int("80A9")
GL_SAMPLE_COVERAGE_VALUE		= hex_to_int("80AA")
GL_SAMPLE_COVERAGE_INVERT		= hex_to_int("80AB")
GL_MULTISAMPLE_BIT			= hex_to_int("0x20000000")

-- transpose_matrix 
GL_TRANSPOSE_MODELVIEW_MATRIX		= hex_to_int("84E3")
GL_TRANSPOSE_PROJECTION_MATRIX		= hex_to_int("84E4")
GL_TRANSPOSE_TEXTURE_MATRIX		= hex_to_int("84E5")
GL_TRANSPOSE_COLOR_MATRIX		= hex_to_int("84E6")

-- texture_env_combine 
GL_COMBINE				= hex_to_int("8570")
GL_COMBINE_RGB				= hex_to_int("8571")
GL_COMBINE_ALPHA			= hex_to_int("8572")
GL_SOURCE0_RGB				= hex_to_int("8580")
GL_SOURCE1_RGB				= hex_to_int("8581")
GL_SOURCE2_RGB				= hex_to_int("8582")
GL_SOURCE0_ALPHA			= hex_to_int("8588")
GL_SOURCE1_ALPHA			= hex_to_int("8589")
GL_SOURCE2_ALPHA			= hex_to_int("858A")
GL_OPERAND0_RGB				= hex_to_int("8590")
GL_OPERAND1_RGB				= hex_to_int("8591")
GL_OPERAND2_RGB				= hex_to_int("8592")
GL_OPERAND0_ALPHA			= hex_to_int("8598")
GL_OPERAND1_ALPHA			= hex_to_int("8599")
GL_OPERAND2_ALPHA			= hex_to_int("859A")
GL_RGB_SCALE				= hex_to_int("8573")
GL_ADD_SIGNED				= hex_to_int("8574")
GL_INTERPOLATE				= hex_to_int("8575")
GL_SUBTRACT				= hex_to_int("84E7")
GL_CONSTANT				= hex_to_int("8576")
GL_PRIMARY_COLOR			= hex_to_int("8577")
GL_PREVIOUS				= hex_to_int("8578")

-- texture_env_dot3 
GL_DOT3_RGB				= hex_to_int("86AE")
GL_DOT3_RGBA				= hex_to_int("86AF")

-- texture_border_clamp 
GL_CLAMP_TO_BORDER			= hex_to_int("812D")


--
-- GL_ARB_multitexture (ARB extension 1 and OpenGL 1.2.1)
--

GL_TEXTURE0_ARB				= hex_to_int("84C0")
GL_TEXTURE1_ARB				= hex_to_int("84C1")
GL_TEXTURE2_ARB				= hex_to_int("84C2")
GL_TEXTURE3_ARB				= hex_to_int("84C3")
GL_TEXTURE4_ARB				= hex_to_int("84C4")
GL_TEXTURE5_ARB				= hex_to_int("84C5")
GL_TEXTURE6_ARB				= hex_to_int("84C6")
GL_TEXTURE7_ARB				= hex_to_int("84C7")
GL_TEXTURE8_ARB				= hex_to_int("84C8")
GL_TEXTURE9_ARB				= hex_to_int("84C9")
GL_TEXTURE10_ARB			= hex_to_int("84CA")
GL_TEXTURE11_ARB			= hex_to_int("84CB")
GL_TEXTURE12_ARB			= hex_to_int("84CC")
GL_TEXTURE13_ARB			= hex_to_int("84CD")
GL_TEXTURE14_ARB			= hex_to_int("84CE")
GL_TEXTURE15_ARB			= hex_to_int("84CF")
GL_TEXTURE16_ARB			= hex_to_int("84D0")
GL_TEXTURE17_ARB			= hex_to_int("84D1")
GL_TEXTURE18_ARB			= hex_to_int("84D2")
GL_TEXTURE19_ARB			= hex_to_int("84D3")
GL_TEXTURE20_ARB			= hex_to_int("84D4")
GL_TEXTURE21_ARB			= hex_to_int("84D5")
GL_TEXTURE22_ARB			= hex_to_int("84D6")
GL_TEXTURE23_ARB			= hex_to_int("84D7")
GL_TEXTURE24_ARB			= hex_to_int("84D8")
GL_TEXTURE25_ARB			= hex_to_int("84D9")
GL_TEXTURE26_ARB			= hex_to_int("84DA")
GL_TEXTURE27_ARB			= hex_to_int("84DB")
GL_TEXTURE28_ARB			= hex_to_int("84DC")
GL_TEXTURE29_ARB			= hex_to_int("84DD")
GL_TEXTURE30_ARB			= hex_to_int("84DE")
GL_TEXTURE31_ARB			= hex_to_int("84DF")
GL_ACTIVE_TEXTURE_ARB			= hex_to_int("84E0")
GL_CLIENT_ACTIVE_TEXTURE_ARB		= hex_to_int("84E1")
GL_MAX_TEXTURE_UNITS_ARB		= hex_to_int("84E2")


GL_FRAGMENT_PROGRAM_POSITION_MESA       = hex_to_int("8bb0")
GL_FRAGMENT_PROGRAM_CALLBACK_MESA       = hex_to_int("8bb1")
GL_FRAGMENT_PROGRAM_CALLBACK_FUNC_MESA  = hex_to_int("8bb2")
GL_FRAGMENT_PROGRAM_CALLBACK_DATA_MESA  = hex_to_int("8bb3")
GL_VERTEX_PROGRAM_POSITION_MESA         = hex_to_int("8bb4")
GL_VERTEX_PROGRAM_CALLBACK_MESA         = hex_to_int("8bb5")
GL_VERTEX_PROGRAM_CALLBACK_FUNC_MESA    = hex_to_int("8bb6")
GL_VERTEX_PROGRAM_CALLBACK_DATA_MESA    = hex_to_int("8bb7")

gl.glGetFloatv = gl.glGetDoublev
gl.glGetIntegerv = gl.glGetDoublev
gl.glGetBooleanv = function(pname)	
	local ret = gl.glGetDoublev(pname)
	for i=1,table.getn(ret) do
		if(ret[i]==1) then ret[i]=true else ret[i]=false end
	end
	return ret
end

gl.glBeginEnd = function(what,proc)
    gl.glBegin(what)
    proc()
    gl.glEnd()
end

gl.glEnableDisable = function(capabilities,proc)
    for i=1,table.getn(capabilities) do gl.glEnable(capabilities[i]) end
    proc()
    for i=1,table.getn(capabilities) do gl.glDisable(capabilities[i]) end
end

gl.glVertex2f = gl.glVertex
gl.glVertex3f = gl.glVertex
gl.glVertex4f = gl.glVertex

gl.glTranslatef = gl.glTranslated
gl.glTranslate = gl.glTranslated

gl.glRotatef = gl.glRotated
gl.glRotate = gl.glRotated

gl.glScale = gl.glScaled
gl.glScalef = gl.glScaled

gl.glRectf = gl.glRect
gl.glRectd = gl.glRect


